<!--
    Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)
    
    SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import Modal from '@/components/general/Modal.vue';
import { computed, inject, ref } from 'vue';
import { useDashboardStore } from '@/stores/dashboard';
import { storeToRefs } from 'pinia';
import { request } from '@/lib/request';
import Checkbox from '@/components/general/form/Checkbox.vue';
import type { folder } from '@/types/dashboard';

type dataFolder = {
    deletePanes?: boolean
}

const store = useDashboardStore();
const { folderId, allFolders } = storeToRefs(store);
const deletePanes = ref(false);

const emits = defineEmits<{
    (e: 'submit'): void,
    (e: 'cancel'): void
}>();

const panes = allFolders.value?.find((folder:folder)=>folder.id === folderId.value || folder.parent === folderId.value)?.panes?.map((pane)=>pane.hash_pane);
let configuration = inject<any>('configuration');
const submit = async ()=>{
    const data:dataFolder = {};
    if(deletePanes.value){
        data.deletePanes = true;
    }
    const url = configuration.apiServer+`/api/overview/folder/${folderId.value}`;
    const response = await request('DELETE',url, data, 'application/json', false, true);
    if(response && response.success){
        store.reset();
        emits(`submit`);
    }else{
        console.error("ERROR");
    }
};
const cancel = ()=>{
    store.reset();
    emits(`cancel`);
};

const localDeletePanes = computed({
    get(){
        return deletePanes.value;
    },
    set(newValue){
        deletePanes.value = newValue;
        if(newValue)
            showConfirmDeletePanes.value = true;
    }
})

const showConfirmDeletePanes = ref(false);

const confirmDeletePanes = ()=>{
    showConfirmDeletePanes.value = false;
}
const cancelDeletePanes = ()=>{
    deletePanes.value = false;
    showConfirmDeletePanes.value = false;
}


</script>
<template>
    <div>
        <Modal :header="$t('dashboardPage.folder.delete.label')" :text="$t('dashboardPage.folder.delete.sureDelete')" :labelSubmit="$t('general.buttons.confirm')" @submit="submit" :labelCancel="$t('general.buttons.cancel')" @cancel="cancel">
            <form class="flex flex-col mt-4" @submit.prevent>
                <Checkbox :label="$t('dashboardPage.folder.delete.deletePanes')" v-model="localDeletePanes" v-if="panes && panes.length>0"/>
            </form>
            <Modal :header="$t('dashboardPage.folder.delete.deletePanes')" :text="$t('dashboardPage.folder.delete.warnPanes')" :labelSubmit="$t('general.buttons.confirm')" @submit="confirmDeletePanes" :labelCancel="$t('general.buttons.cancel')" @cancel="cancelDeletePanes" v-if="showConfirmDeletePanes">
            </Modal>
        </Modal>
    </div>
</template>